import numpy as np
import matplotlib.pyplot as plt
from Fonction_transformation import rotation2D, translation2D

#Transpose F1 pour alléger la notation de np.array
F1=np.array([[0,1,1,3,3,1,1,0],[0,-1,-0.5,-0.5,0.5,0.5,1,0]]).T

ti,tf,npts=0,2*np.pi,100      # Rotation de t = 0 à 2 pi 
t=np.linspace(ti,tf,npts)

#Equation paramétrique d'une ellipse en t
x,y=10*np.cos(t),5*np.sin(t)
plt.plot(F1[:,0],F1[:,1])     # Flèche initiale
plt.plot(x,y,'-b')            # Ellipse
plt.axis('equal')             # Échelle égale en x et y

#Boucle de rotation et translation à partir de F1 initiale
for i in range(0,npts,10):
    F2=rotation2D(F1, t[i])          # Rotation de F1 initiale
    F2=translation2D(F2,[x[i],y[i]]) # Placer la pointe sur l'éllipse
    plt.plot(F2[:,0],F2[:,1])
   
    