import numpy as np
import matplotlib.pyplot as plt
from Fonction_transformation import rotation2D, translation2D

#Transpose F1 pour alléger la notation de np.array
F1=np.array([[0,1,1,3,3,1,1,0],[0,-1,-0.5,-0.5,0.5,0.5,1,0]]).T

ti,tf,npts=0,2*np.pi,100      # Rotation de t = 0 à 2 pi 
t=np.linspace(ti,tf,npts)
delt=2*np.pi/10               # Angle de rotation relative constant

#Equation paramétrique d'une ellipse
x,y=10*np.cos(t),5*np.sin(t)
plt.plot(F1[:,0],F1[:,1])     # Flèche initiale
plt.plot(x,y,'-b')            # Ellipse bleue
plt.axis('equal')             # Échelle égale en x et y

#Boucle de translation et rotation pour la prochaine étape
for i in range(0,npts,10):
    F2=F1+[x[i],y[i]]         # F2=translation2D(F1,[x[i],y[i]])
    plt.plot(F2[:,0],F2[:,1])
    F1=rotation2D(F1, delt)   # Rotation relative additionnelle