import numpy as np
import matplotlib.pyplot as plt

#Approximation de moindre carré de degré 2 avec 4 équations
#Système sur-contraint
xP=np.array([1,4,7,8])
yP=np.array([1,5,5,3])
x=np.linspace(0,10,25)
#==================  Degré 2   ================================
M=np.vstack((xP**2,xP**1,xP**0)).T  #Empile 3 lignes de 4 valeurs, puis transpose
a=np.linalg.pinv(M).dot(yP)         #Résolution a=M^p * yp
#a=np.polyfit(xP,yP,2)              #Résolution avec polyfit de numpy
y1=np.polyval(a,x)                  #Calcul y=a_0 x^2 + a_1 x^1 + a_2
#y=a[0]*x**2+a[1]*x**1+a[2]*x**0    #Calcul y=a_0 x^2 + a_1 x^1 + a_2 (aussi)
print('Degre 2: a.T=',a.T)
#=================   Degré 1     ===============================
M=np.vstack((xP**1,xP**0)).T        #Empile 2 lignes de 4 valeurs, puis transpose
a=np.linalg.pinv(M).dot(yP)         #Résolution a=M^p * yp
y2=np.polyval(a,x)                  #Calcul y= a_0 x^1 + a_1
print('Degre 1: a.T=',a.T)

#================= Traçage de graphique =======================
plt.plot(x,y1,'-b',label='Degré 2')
plt.plot(x,y2,'-r',label='Degré 1')
plt.plot(xP,yP,'or')
plt.grid(axis='both')
plt.legend()


